#ifndef VECTOR2_H
#define VECTOR2_H

#include <iostream>
using std::ostream;
/**
* \class Vector2
* \brief Class for creatinga 2D line.
*/
class Vector2 {

public:


	/// x-coordinate
	float x;
	/// y-coordinate
	float y;
	
	/// Contructor for creating a vector with default parameters.
	Vector2();
	
	/*!
	* Contructor for creating a vector with default parameters.
	* \param nx - x-coordinate
	* \param ny - y-coordinate
	*/
	Vector2(float nx, float ny);
	
	/*!
	* \fn float distanceFrom(Vector2 v)
	* For finding the distance between two points.
	* \param v - given point.
	* \return distance from v.
	*/
	float distanceFrom(Vector2 v);

};

ostream& operator << (ostream& out, Vector2 v);
#endif 
